//=============================================================================
//
// file :         XPADClass.h
//
// description :  Include for the XPADClass root class.
//                This class is represents the singleton class for
//                the XPAD device class.
//                It contains all properties and methods which the 
//                XPAD requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: picca $
//
// $Revision: 1.8 $
//
// $Log: XPADClass.h,v $
// Revision 1.8  2009/03/25 14:12:33  picca
// * add the exposure attribute
//
// Revision 1.7  2009/03/25 13:07:08  picca
// * rename the intensity -> intensities
// * add a new intensity scalar attribute #12131
//
// Revision 1.6  2008/12/11 14:52:05  picca
// * add the intensity attribute
//
// Revision 1.5  2008/06/02 14:38:19  picca
// * first working version
//
// Revision 1.4  2008/02/22 10:16:07  picca
// * use a DevLong for the image attribut instead of DevULong
//
// Revision 1.3  2008/02/21 17:02:53  picca
// * first linux compilable version
//
// Revision 1.2  2008/02/14 11:51:17  elattaoui
// Start and DarkAcquisition commands added
//
// Revision 1.1  2008/01/23 15:25:39  le
// initial import
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _XPADCLASS_H
#define _XPADCLASS_H

#include <tango.h>
#include <XPAD.h>


namespace XPAD_ns
{//=====================================
//	Define classes for attributes
//=====================================
class ImfpAttrib: public Tango::ImageAttr
{
public:
	ImfpAttrib():ImageAttr("Imfp", Tango::DEV_LONG, Tango::READ_WRITE, 8192, 8192) {};
	~ImfpAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_Imfp(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<XPAD *>(dev))->write_Imfp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_Imfp_allowed(ty);}
};

class ItuneAttrib: public Tango::ImageAttr
{
public:
	ItuneAttrib():ImageAttr("Itune", Tango::DEV_LONG, Tango::READ_WRITE, 8192, 8192) {};
	~ItuneAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_Itune(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<XPAD *>(dev))->write_Itune(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_Itune_allowed(ty);}
};

class ithlAttrib: public Tango::ImageAttr
{
public:
	ithlAttrib():ImageAttr("ithl", Tango::DEV_LONG, Tango::READ_WRITE, 8192, 8192) {};
	~ithlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_ithl(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<XPAD *>(dev))->write_ithl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_ithl_allowed(ty);}
};

class daclAttrib: public Tango::ImageAttr
{
public:
	daclAttrib():ImageAttr("dacl", Tango::DEV_LONG, Tango::READ_WRITE, 8192, 8192) {};
	~daclAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_dacl(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<XPAD *>(dev))->write_dacl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_dacl_allowed(ty);}
};

class imageAttrib: public Tango::ImageAttr
{
public:
	imageAttrib():ImageAttr("image", Tango::DEV_LONG, Tango::READ, 8192, 8192) {};
	~imageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_image(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_image_allowed(ty);}
};

class gateModeAttrib: public Tango::Attr
{
public:
	gateModeAttrib():Attr("gateMode", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~gateModeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_gateMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<XPAD *>(dev))->write_gateMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_gateMode_allowed(ty);}
};

class gateNumberAttrib: public Tango::Attr
{
public:
	gateNumberAttrib():Attr("gateNumber", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~gateNumberAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_gateNumber(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<XPAD *>(dev))->write_gateNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_gateNumber_allowed(ty);}
};

class exposureAttrib: public Tango::Attr
{
public:
	exposureAttrib():Attr("exposure", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~exposureAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<XPAD *>(dev))->read_exposure(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<XPAD *>(dev))->write_exposure(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<XPAD *>(dev))->is_exposure_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class LoadDefaultConfigGCmd : public Tango::Command
{
public:
	LoadDefaultConfigGCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LoadDefaultConfigGCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LoadDefaultConfigGCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<XPAD *>(dev))->is_LoadDefaultConfigG_allowed(any);}
};



class LoadFlatDaclCmd : public Tango::Command
{
public:
	LoadFlatDaclCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LoadFlatDaclCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LoadFlatDaclCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<XPAD *>(dev))->is_LoadFlatDacl_allowed(any);}
};



class CalibrateCmd : public Tango::Command
{
public:
	CalibrateCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CalibrateCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CalibrateCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<XPAD *>(dev))->is_Calibrate_allowed(any);}
};



class ResetCmd : public Tango::Command
{
public:
	ResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<XPAD *>(dev))->is_Reset_allowed(any);}
};



class LoadCalibrationCmd : public Tango::Command
{
public:
	LoadCalibrationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LoadCalibrationCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LoadCalibrationCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<XPAD *>(dev))->is_LoadCalibration_allowed(any);}
};



class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<XPAD *>(dev))->is_Stop_allowed(any);}
};



class StartClass : public Tango::Command
{
public:
	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<XPAD *>(dev))->is_Start_allowed(any);}
};



//
// The XPADClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	XPADClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static XPADClass *init(const char *);
	static XPADClass *instance();
	~XPADClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	XPADClass(string &);
	static XPADClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace XPAD_ns

#endif // _XPADCLASS_H
